<template>
  <div id="toasts" aria-live="polite" aria-atomic="true">
    <!-- Then put toasts within -->
    <transition-group tag="div" name="toast"
      @enter="enter" @leave="enter"
      @before-enter="beforeEnter"
      @before-leave="beforeLeave"
      :css="false">
      <div v-for="item of items" :key="item.id"
        :class="toastClasses(item)"
        aria-live="assertive" aria-atomic="true"
        role="alert">
        <div class="toast-header">
          <strong class="mr-auto" v-html="item.title"></strong>
          <close-btn @close="close(item)" dismiss="toast"/>
        </div>

        <div class="toast-body" v-html="item.body"></div>
      </div>
    </transition-group>
  </div>
</template>

<script>
import { mapMutations, mapState } from 'vuex'
import CloseBtn from './close-btn'

export default {
  name: 'toasts',

  components: {
    CloseBtn
  },

  watch: {
    items (item) {
      if (item.status === 401) {
        this.$router.push({ name: 'login' })
        this.$store.commit('authenticate', {})
      }
    }
  },

  computed: {
    ...mapState('notifications', ['items'])
  },

  methods: {
    ...mapMutations('notifications', ['clear']),

    toastClasses (item) {
      const classes = ['toast', `toast-${item.type}`]

      // if (item.show) {
      //   classes.push('show')
      // }

      return classes
    },

    push ({ title, body, type = 'default', status = 200 }) {
      const validTypes = ['info', 'warning', 'danger', 'success']
      const item = {
        id: this.items.length + 1,
        show: true,
        type: validTypes.includes(type) ? type : 'default',
        status,
        title,
        body
      }

      this.$store.commit('notifications/push', item)

      // item.timer = setTimeout(() => {
      //   this.close(item)
      // }, 2000)
    },

    close (item) {
      // if (item.timer) {
      //   clearTimeout(item.timer)
      // }

      this.$store.commit('notifications/close', item)
    },

    enter (el, done) {
      el.classList.remove('showing')
      console.log('enter', el)
      done()
    },

    leave (el, done) {
      el.classList.remove('showing')
      console.log('leave', el)
      done()
    },

    beforeEnter (el) {
      el.classList.add('showing', 'show')
      console.log('beforeEnter', el)
    },

    beforeLeave (el) {
      el.classList.add('showing', 'hide')
      console.log('beforeLeave', el)
    }
  },

  mounted () {
    app.$on('notify', this.push)
  }
}
</script>

<style lang="scss" scoped>
@import '~bootstrap/scss/toasts';

#toasts {
  position: fixed;
  bottom: 1rem;
  left: 1rem;
  min-width: 350px;
  z-index: 1040;
}

.fade {
  &-enter-active,
  &-leave-active {
    transition: height 0.2s, opacity 0.2s;
    transition-timing-function: ease;
    overflow: hidden;
  }

  &-enter,
  &-leave-active {
    opacity: 0
  }
}

.toast {
  &,
  &-enter-active,
  &-leave-active {
    transition: all 0.3s ease-in-out;
  }

  @each $color, $value in $theme-colors {
    &-#{$color} {
      background-color: theme-color-level($color, $alert-bg-level);
      border-color: theme-color-level($color, $alert-border-level);
      color: theme-color-level($color, $alert-color-level);

      .toast-header {
        background-color: theme-color-level($color, $alert-bg-level);
        border-color: theme-color-level($color, $alert-border-level);
        color: theme-color-level($color, $alert-color-level);
      }
    }
  }
}
</style>
